;Find The Smiley by Shiru (shiru@mail.ru) 09'10


    device zxspectrum48

STACK_A     equ #2d28
FP_TO_A     equ #2dd5

OP_ADDAC	equ #89
OP_SUBC		equ #91

;DOWN_HL+ by Spencer Winsent

	macro downHLm
    inc h
    ld a,h
    and #07
    jr nz,$+11
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    ld h,a
	endm

    org #8000

begin
    di
    ;ld sp,#ffff	;stack is set by Hrust depacker
	ld bc,#7ffd
	ld a,16+7
	out (c),a

	xor a
	out (#fe),a
	ld h,#40
	ld b,#1b
	call fillBlock

makeFont
	ld hl,fontGfx
	ld de,fontGfx+48
	ld b,6*3

.l0
	push bc
	ld bc,8*256+1
.l1
	push bc
	push hl
	ld b,1
.l2
	ld a,(hl)
	and c
	sub c
	ccf
	rl b
	inc hl
	jr nc,.l2
	ld a,b
	ld (de),a
	inc de
	pop hl
	pop bc
	sla c
	djnz .l1
	ld c,8
	add hl,bc
	pop bc
	djnz .l0

makeScrTab
	ld h,b
	ld l,b
	ld de,scrTab
.l0
	ld a,l
	ld (de),a
	inc d
	ld a,h
	ld (de),a
	dec d
	inc e
	call downHL
	djnz .l0

mirrorSprite
	ld hl,spriteGfx
	ld ix,sprite
	ld b,2
.l00
	push bc
	ld a,48
.l0
	ld c,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld (ix),c
	ld (ix+1),d
	ld (ix+2),e
	ld b,8*3
.l1
	rl e
	rl d
	rl c
	rr (ix+3)
	rr (ix+4)
	rr (ix+5)
	djnz .l1
	ld c,6
	add ix,bc
	dec a
	jr nz,.l0
	ld c,512-288
	add ix,bc
	pop bc
	djnz .l00

makeSprite
	ld hl,sprite
	ld c,7
.l0
	ld d,h
	ld e,l
	ld b,4
	ld a,h
	add a,b
	ld h,a
.l1
	ld a,(de)
	ld (hl),a
	rr (hl)
	inc de
	inc l
	jr nz,.l1
	inc h
	djnz .l1
	ex de,hl
	dec c
	jr nz,.l0

makePath
	ld hl,sinTable
	ld de,pathY
	ld bc,64
	ldir
	ld b,64
.l1
	dec hl
	ld a,(hl)
	ld (de),a
	inc e
	djnz .l1
	ld h,d
	ld l,e
	;ld b,128
.l2
	dec b
	dec de
	ld a,(de)
	cpl
	ld (hl),a
	inc l
	djnz .l2

	ld de,pathX1+64
	ld c,3
.l3
	;ld hl,pathY
	;ld b,0
.l4
	ld a,(hl)
	ld (de),a
	inc l
	inc e
	djnz .l4
	inc d
	dec c
	jr nz,.l3

	;ld hl,pathY
	;ld b,0
.l5
	push bc
	push hl
	ld a,16
	call STACK_A
	ld a,9
	call STACK_A
	pop hl
	push hl
	ld a,(hl)
	add a,128
	call STACK_A
	rst #28
	db #04,#01,#05,#38
	call FP_TO_A
	pop hl
	pop bc
	;sub 8
	ld (hl),a
	inc l
	djnz .l5

	;ld hl,pathX1
	inc h
	;ld b,0
.l6
	ld a,(hl)
	add a,100
	ld (hl),a
	inc l
	djnz .l6

	;ld hl,pathX2
	inc h
	;ld b,0
.l7
	ld a,(hl)
	add a,120
	srl a
	ld (hl),a
	inc l
	djnz .l7

	;ld hl,pathX3
	inc h
	;ld b,0
.l8
	ld a,(hl)
	add a,128
	srl a
	add a,76
	ld (hl),a
	inc l
	djnz .l8

makeRotAnim
	ld hl,rotAnim
	xor a
.l0
	add a,4
	push af
	push hl

	push hl
	ld c,a
	ld b,64
.l1
	ld (hl),0
	inc hl
	djnz .l1
	pop ix

	ld hl,64*256
	push hl
	ld d,b
	ld e,b
.l2
	inc de
	sbc hl,bc
	jr nc,.l2

	pop hl
	push af
	ld a,h
	sub c
	srl a
	ld c,a
	add ix,bc
	pop af

	ld b,a
.l3
	ld (ix),h
	add hl,de
	inc ix
	djnz .l3
	pop hl
	ld c,64
	add hl,bc
	pop af
	cp 68
	jr nz,.l0

	ei

titleScreen
	ld hl,msgTitle1
	call drawLargeMsgX2
	ld d,#48
	call changeEffect

	call checkKey
	ld hl,sfxStart
	call sfx
	;ld d,#48
	call clearEffect

	ld hl,level
	ld (hl),1
	inc hl
	xor a
	ld (hl),a
	inc hl
	ld (hl),2
	inc hl
	ld (hl),a

	call drawShellsCol
	call rotateIn

levelInit
	ld hl,msgRound
	call drawLargeMsg
	ld a,e
	add a,8
	ld e,a
	ld a,(level)
	call drawLargeChar

	ld d,#40
	call changeEffect

	ld b,25
	halt
	djnz $-1

	call drawShells
	call rotateOut
	ld h,#59
	;ld b,1
	inc b
	ld a,5+64
	call fillBlock
	call drawShellsEmpty
	call rotateIn

	ld d,#40
	call clearEffect
	ld h,#58
	ld b,3
	ld a,5+64
	call fillBlock

	;ld a,#40
	ld a,d
	ld (scrPos.scr),a

	ld a,(level)
	;ld b,0
	ld c,a
	ld hl,levels-2
	add hl,bc
	add hl,bc
	ld b,(hl)
	inc hl
	ld c,(hl)

exchangeSet
	ld a,r
.num=$+1
	xor 53
	add a,a
	jr nc,$+4
	xor 51
	ld (.num),a
	and 3
	or a
	ld de,2
	ld hl,(pathX1&#ff00)+128-24-4
	jr z,.l0
	cp 1
	ld de,1
	ld hl,(pathX2&#ff00)+208-24-4
	jr z,.l0
	cp 2
	ld de,1*256+2
	ld hl,(pathX3&#ff00)+48-24-4
	jr z,.l0
	ld hl,exchangeLoop.addsub
	ld a,(hl)
	xor #18
	ld (hl),a
	jr exchangeSet
.l0
	push hl
	push bc
	ld hl,shells
	push hl
	ld a,d
	ld d,0
	add hl,de
	ld b,h
	ld c,l
	ld e,a
	pop hl
	add hl,de
	ld a,(bc)
	ld e,(hl)
	ld (hl),a
	ld a,e
	ld (bc),a
	pop bc
	pop hl
	ld a,l
	ld (exchangeLoop.off),a
	ld l,128

exchangeLoop
	push bc
	ld c,sprite/256
	halt
	ld a,h
	ld h,pathY/256
	ld d,(hl)
	ld h,a
	ld e,(hl)
	ld (.pos1),de
	call drawSprite
	push hl
	ld a,l
	add a,128
	ld l,a
	ld a,h
	ld h,pathY/256
	ld d,(hl)
	ld h,a
	ld e,(hl)
	ld (.pos2),de
	inc l
	call drawSprite
.off=$+1
	ld de,(96-24)*256
	call drawSprite
.pos1=$+1
	ld de,0
	ld bc,500
	dec bc
	ld a,b
	or c
	jr nz,$-3
	call clearRect
.pos2=$+1
	ld de,0
	call clearRect
	pop hl
	pop bc
	ld a,l
.addsub=$
	add a,c
	ld l,a
	jr nc,exchangeLoop
	dec b
	jp nz,exchangeSet

selectShell
	ld de,#4000
	halt
	call drawShellsA
	ld hl,msgSelect
	call drawLargeMsgX2
	call drawLargeMsg
	ld d,#50
	call changeEffect

.l0
	call checkKey
	sub 49
	cp 3
	jr nc,.l0

	push af
	ld hl,sfxSelect
	call sfx
	pop af

	ld hl,#5a01
	ld bc,3*256
.l1
	push bc
	cp c
	jr z,.l4
	push hl
	ld b,8
.l2
	push bc
	ld b,10
.l3
	ld (hl),1
	inc l
	djnz .l3
	ld c,22
	add hl,bc
	pop bc
	djnz .l2
	pop hl
.l4
	ld bc,10
	add hl,bc
	pop bc
	inc c
	djnz .l1

	push af

	call drawShellsEmpty
	call rotateOut
	call drawShellsCol
	call rotateIn

	pop af
	ld b,0
	ld c,a
	ld hl,shells
	add hl,bc
	ld a,(hl)
	or a
	jr z,wrong

correct
	ld hl,sfxCorrect
	ld de,msgGood
	call showMessageTop

	ld hl,level
	inc (hl)
	ld a,(hl)
	cp 10
	jp c,levelInit

welldone
	ld hl,msgWellDone
	jr showMessageMid

wrong
	ld hl,sfxWrong
	ld de,msgWrong
	call showMessageTop

	ld hl,msgYouLose
	jr showMessageMid

showMessageTop
	call sfx
	ex de,hl
	call drawLargeMsg

	ld d,#40
	call changeEffect

	ld b,50
	halt
	djnz $-1

	;ld d,#40
	call clearEffect

	ld d,#50
	jp clearEffect

showMessageMid
	push hl
	call drawShells
	call rotateOut
	call clearBuf
	ld h,#40
	ld b,#1b
	call fillBlock

	pop hl
	call drawLargeMsgX2

	ld d,#48
	call changeEffect

	call checkKey

	ld hl,sfxSelect
	call sfx

	;ld d,#48
	call clearEffect

	jp titleScreen

checkKey
	xor a
	ld (iy-50),a
    res 5,(iy+1)
.l0
    bit 5,(iy+1)
    jr z,.l0
    ld a,(iy-50)
	ret

downHL
    inc h
    ld a,h
    and #07
    ret nz
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    ld h,a
	ret

;in: D=y,E=x
;out: DE=adr,H=y,L=x

scrPos
	push de
	ld h,scrTab/256
	ld l,d
	ld a,e
	srl a
	srl a
	srl a
	add a,(hl)
	ld e,a
	inc h
	ld a,(hl)
.scr=$+1
	add a,0
	ld d,a
	pop hl
	ret

;in: D=y,E=x,C=sprite offset

drawSprite
	push bc
	push de
	push hl
	call scrPos

	ld a,l
	and 7
	add a,a
	add a,a
	add a,c
	ld h,a
	ld a,l
	ld l,0

	di
	ld (.sp),sp
	ld sp,hl
	ex de,hl

	ld de,#ff00
	and 7
	jr z,.l1
.l0
	scf
	ccf
	rr d
	rr e
	dec a
	jr nz,.l0
.l1
	ld a,d
	ld (.ledge),a
	ld a,e
	ld (.redge),a

	ld a,48
.l2
	exa
	ld e,l
	pop bc
	ld a,c
	ld d,a
.ledge=$+1
	and 0
	or (hl)
	ld (hl),a
	inc l
	ld a,b
	or (hl)
	ld (hl),a
	inc l
	pop bc
	ld a,c
	or (hl)
	ld (hl),a
	inc l
	ld a,b
	or (hl)
	ld (hl),a
	inc l
	pop bc
	ld a,c
	or (hl)
	ld (hl),a
	inc l
	ld a,b
	or (hl)
	ld (hl),a
	inc l
	ld a,d
.redge=$+1
	and 0
	or (hl)
	ld (hl),a
	ld l,e
	downHLm
	exa
	dec a
	jr nz,.l2

.sp=$+1
	ld sp,0
	ei
	pop hl
	pop de
	pop bc
	ret

drawShellsEmpty
	ld de,#4000
	jr drawShells.masked
drawShells
	ld de,shells
.masked
	call clearBuf
	ld a,#c0
	ld (scrPos.scr),a
drawShellsA
	push de
	push de
	pop ix
	ld de,72*256+20
	ld b,3
.l0
	ld a,sprite/256
	add a,(ix)
	ld c,a
	call drawSprite
	ld a,e
	add a,80
	ld e,a
	inc ix
	djnz .l0
	pop de
	ret

drawShellsCol
	call drawShells
	ld hl,#5901
.l0
	ld b,10
	ld a,(de)
	or a
	ld a,4+64
	jr z,.l1
	ld a,6+64
.l1
	ld (hl),a
	inc l
	djnz .l1
	ld c,22
	add hl,bc
	ld a,h
	cp #5a
	jr c,.l0
	ld bc,-256+10
	add hl,bc
	inc de
	ld a,l
	cp 31
	jr c,.l0
	ret

fillBlock
	ld l,0
.l0
	ld (hl),a
	inc l
	jr nz,.l0
	inc h
	djnz .l0
	ret

clearRect
	call scrPos
	ex de,hl
	ld b,48
.l0
	ld e,l
	xor a
	dup 7
	ld (hl),a
	inc l
	edup
	org $-1
	ld l,e
	call downHL
	djnz .l0
	ret

drawChar
	push bc
	push de
	push hl
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fontGfx
	add hl,bc
	dup 8
	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	edup
	pop hl
	pop de
	pop bc
	ret

drawLargeChar
	push bc
	push de
	push hl
	push ix
	ld h,0
	ld l,a
	ld b,h
	ld c,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,chrData
	add hl,bc
	ld a,#c0
	ld (scrPos.scr),a
	ld c,3
.l0
	push de
	push hl
	call scrPos
	pop hl
	ld b,3
.l1
	ld a,(hl)
	inc hl
	cp 255
	call nz,drawChar
	inc e
	djnz .l1
	ld a,d
	and #18
	rrca
	rrca
	rrca
	or #58
	ld d,a
	ld b,3
	ld a,(ix)
	inc ix
	dec e
	ld (de),a
	djnz $-2
	pop de
	ld a,d
	add a,8
	ld d,a
	dec c
	jr nz,.l0
	pop ix
	pop hl
	pop de
	pop bc
	ld a,e
	add a,24
	ld e,a
	ret

drawLargeMsgX2
	call drawLargeMsg
drawLargeMsg
	ld a,(hl)
	add a,a
	add a,(hl)
	inc hl
	ld b,0
	ld c,a
	ld ix,palettes
	add ix,bc
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
.l0
	ld a,(hl)
	inc hl
	cp 254
	jr nz,.l1
	ld a,e
	add a,8
	ld e,a
	jr .l0
.l1
	cp 255
	ret z
	call drawLargeChar
	jr .l0

clearEffect
	call clearBuf
changeEffect
	ld b,8
	ld e,0
.l0
	push de
	ex de,hl
	halt
	ld c,32
.l1
	ld a,h
	add a,scrBuf/256-#40
	ld d,a
	ld e,l
	ld a,l
	dup 16
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	edup
	ld l,a
	call downHL
	ld a,h
	add a,scrBuf/256-#40
	ld d,a
	ld e,l
	ld a,l
	dup 16
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rr (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	ex de,hl
	rl (hl)
	inc l
	edup
	ld l,a
	call downHL
	dec c
	jp nz,.l1
	pop de
	dec b
	jp nz,.l0

clearBuf
	xor a
	ld h,scrBuf/256
	ld b,6144/256
	jp fillBlock

rotateIn
	ld bc,1
	jr rotateEffect
rotateOut
	ld bc,15*256-1

;B=start frame, C=delta

rotateEffect
	ld a,#40
	ld (scrPos.scr),a
	ld a,b
	ld b,16
.l0
	push bc
	push af
	ld l,0
	srl a
	rr l
	srl a
	rr l
	add a,rotAnim/256
	ld h,a
	push hl
	pop ix
	halt
	ld de,64*256
.l1
	push de
	call scrPos
	push de
	ld d,(ix)
	ld e,0
	call scrPos
	add a,scrBuf/256-#40
	ld d,a
	ex de,hl
	pop de
	dup 32
	ldi
	edup
	pop de
	inc ix
	inc d
	ld a,d
	cp 128
	jr nz,.l1
	pop af
	pop bc
	add a,c
	djnz .l0
	ret

sfx
	di
	push de
.l0
	ld a,(hl)
	or a
	jr z,.l3
	inc hl
	ld c,(hl)
	inc hl
	ld e,0
	ld d,(hl)
	inc hl
	push hl
	ld l,16
	ld h,a
.l1
	ld b,100
.l2
	add ix,de
	sbc a,a
	and l
	out (#fe),a
	ld a,c
	dec a
	jr nz,$-1
	out (#fe),a
	ld a,32
	sub c
	dec a
	jr nz,$-1
	djnz .l2
	dec h
	jr nz,.l1
	pop hl
	jr .l0
.l3
	ei
	pop de
	ret

sfxCorrect
	db 4,31,4000/256
	db 2,31,0
	db 4,31,6000/256
	db 2,31,0
	db 4,4,4000/256
	db 2,4,0
	db 4,4,6000/256
	db 2,31,0
	db 0

sfxWrong
	db 4,31,1500/256
	db 2,31,0
	db 8,31,1200/256
	db 2,31,0
	db 4,4,1200/256
	db 0

sfxSelect
	db 2,16,6000/256
	db 2,24,0
	db 2,8,8000/256
	db 2,16,0
	db 2,1,8000/256
	db 0

sfxStart
	db 2,31,4000/256
	db 2,31,5000/256
	db 2,31,6000/256
	db 2,21,4000/256
	db 2,21,5000/256
	db 2,21,6000/256
	db 2,4,4000/256
	db 2,4,5000/256
	db 2,4,6000/256
	db 2,2,4000/256
	db 2,2,5000/256
	db 2,2,6000/256
	db 0

sinTable
	db #00,#01,#03,#05,#07,#09,#0b,#0d
	db #0f,#11,#13,#15,#17,#19,#1a,#1c
	db #1e,#20,#22,#23,#25,#27,#29,#2a
	db #2c,#2e,#2f,#31,#32,#34,#35,#37
	db #38,#39,#3b,#3c,#3d,#3f,#40,#41
	db #42,#43,#44,#45,#46,#47,#48,#49
	db #49,#4a,#4b,#4b,#4c,#4d,#4d,#4e
	db #4e,#4e,#4f,#4f,#4f,#4f,#4f,#4f

chrData
	db 0,1,18,7,255,7,6,1,12		;0
	db 2,18,255,255,7,255,2,3,14	;1
	db 2,1,18,0,1,12,4,1,14			;2
	db 2,1,18,255,2,5,2,1,12		;3
	db 0,1,16,4,1,9,255,255,8		;4
	db 22,1,14,4,1,18,2,1,12		;5
	db 0,14,255,21,1,18,6,1,12		;6
	db 2,1,16,255,2,9,255,255,8		;7
	db 0,1,18,17,1,5,6,1,12			;8
	db 0,1,18,6,1,9,255,2,12		;9
	db 22,1,18,7,255,7,4,1,12		;D
	db 0,1,14,21,14,255,6,1,14		;E
	db 0,1,14,21,14,255,8,255,255	;F
	db 0,1,14,7,2,16,6,1,10			;G
	db 20,255,20,21,1,9,8,255,8		;H
	db 2,15,14,255,7,255,2,3,14		;I
	db 20,255,255,7,255,255,6,1,14	;L
	db 22,15,18,7,7,7,8,8,8			;M
	db 22,1,18,7,255,7,8,255,8		;N
	db 22,1,18,21,1,5,8,255,8		;R
	db 0,1,14,6,1,18,2,1,12			;S
	db 2,15,14,255,7,255,255,8,255	;T
	db 20,255,20,7,255,7,6,1,12		;U
	db 20,20,20,19,19,19,6,3,12		;W
	db 20,255,20,6,1,9,255,2,12		;Y

palettes
pal1a	db 4,4+64,7+64
pal1b	db 7+64,4+64,4
pal2	db 5,5+64,7+64
pal3	db 6,6+64,7+64
pal4	db 2,2+64,6+64

msgTitle1	db 0,5*8,8*8,12,15,18,10,254,21,14,11,255
msgTitle2	db 1,7*8,12*8,20,17,15,16,11,24,255
msgRound	db 2,6*8,2*8,19,0,22,18,10,255
msgSelect	db 3,4*8,19*8,1,255,3,14*8,19*8,2,255,3,24*8,19*8,3,255
msgGood		db 3,9*8,2*8,13,0,0,10,255
msgWrong	db 4,8*8,2*8,23,19,0,18,13,255
msgYouLose	db 4,4*8,10*8,24,0,22,254,16,0,20,11,255,255,255,255,255
msgWellDone	db 2,3*8,8*8,23,11,16,16,254,10,0,18,11,255
msgYouWon	db 2,6*8,12*8,24,0,22,254,23,0,18,255

levels
	db 5,2
	db 7,3
	db 10,4
	db 12,5
	db 14,6
	db 18,7
	db 22,8
	db 26,9
	db 32,10

spriteGfx
	incbin "spriteha.bin"
	incbin "spritehb.bin"

fontGfx
	db %00000000
	db %00000111
	db %00011111
	db %00111111
	db %00111111
	db %01111111
	db %01111111
	db %01111111

	db %00000000
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %00000000

	db %00000000
	db %00111111
	db %01111111
	db %01111111
	db %01111111
	db %01111111
	db %00111111
	db %00000000

	db %01111110
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %11111111
	db %00000000

	db %01111110
	db %01111111
	db %01111111
	db %01111111
	db %01111111
	db %01111111
	db %00111111
	db %00000000

	db %11111110
	db %11111110
	db %11111100
	db %11111000
	db %11111000
	db %11111100
	db %11111110
	db %11111110

end

	ds 6*8*3	;rotated tiles

sprData	ds 6*8*6*2

	align 256

sprite	ds 512*16	;shifted sprite

pathY	ds 256
pathX1	ds 256
pathX2	ds 256
pathX3	ds 256
rotAnim	ds 32*64

scrTab	ds 256*2
scrBuf	equ #c000	;6144

level	db 0
shells	ds 3

    display /d,end-begin
    savesna "main.sna",begin
    savebin "code.bin",begin,end-begin